{
--------------------------------------------------------------------------------

Component Name: TADlg
Author: Mats Asplund
Creation: Aug 15, 1999
Version: 1.0
Description:  TADlg is a component for displaying application info to user.              from any given source.
Credit:
EMail:        mats.asplund@telia.com
Site:         http://w1.545.telia.com/~u54503556/delphi/mdp.htm
Legal issues: Copyright (C) 1999 by Mats Asplund
              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

              4. If you decide to use this software in any of your applications.
                 Send me an EMail address and tell me about it.

Quick Reference:
              TDLBox is a descendant from TComponent.

              Published properties:
              Productname: string
              Version: string
              Copyright: string
              Info: string

              Method:
              Execute: Call this to run component.

--------------------------------------------------------------------------------
}
unit ADlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, A;

type
  TADlg = class(TComponent)
  private
    FProductnamn, FVersion, FCopyright, FInfo, FEmail, FSite: string;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    function Execute: boolean;
    property Productname: string read FProductnamn write FProductnamn;
    property Version: string read FVersion write FVersion;
    property Copyright: string read FCopyright write FCopyright;
    property Email: string read FEmail write FEmail;
    property Site: string read FSite write FSite;
    property Info: string read FInfo write FInfo;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MAs Prod.', [TADlg]);
end;

constructor TADlg.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FVersion:='1.1';
  FCopyright:='Mats Asplund / MAs Prod.';
  FInfo:=DateToStr(Date);
  FEmail:='mats.asplund@telia.com';
  FSite:='http://w1.545.telia.com/~u54503556/delphi/mdp.htm';
end;

destructor TADlg.Destroy;
begin
  inherited Destroy;
end;

function TADlg.Execute: boolean;
begin
  try
    AboutBox:=TAboutBox.Create(Application);
    if Productname = '' then
      Productname:= Application.Title;
    if Copyright = '' then
      Copyright:= 'Mats Asplund / MAs Prod.';
    if Info = '' then
      Info:=DateToStr(Date);
    if Version = '' then
      Version:='1.1';
    if Site = '' then
      Site:='http://w1.545.telia.com/~u54503556/delphi/mdp.htm';
    if Email = '' then
      Email:='mats.asplund@telia.com';
    AboutBox.Productname.Caption:=Productname;
    AboutBox.Version.Caption:=Version;
    AboutBox.Copyright.Caption:=Copyright;
    AboutBox.Info.Caption:=Info;
    AboutBox.Site.Caption:=Site;
    AboutBox.Email.Caption:=Email;
    AboutBox.Caption:='About '+Productname;
    with AboutBox do
    begin
      ProgramIcon.Picture.Graphic:= Application.Icon;
      Result:= (ShowModal = IDOK);
    end;
  finally
    AboutBox.Free;
  end;
end;

end.
