unit ClockLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,extctrls;

type
  TClockLabel = class(TCustomLabel)
  private
    { Private declarations }
    //add extctrls into uses statement;
    FTimer: TTimer;
    procedure SetActive(const Value: Boolean);
    function GetActive: Boolean;
    procedure UpdateClock(Sender: Tobject);
  protected
    { Protected declarations }

  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
  published
    { Published declarations }
    property Align;
    property Alignment;
    property Color;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TransParent;
    property Visible;
    property Active:Boolean read GetActive write SetActive;
  end;

procedure Register;

implementation
{Register needs upperCase}
procedure Register;
begin
  RegisterComponents('myContrals', [TClockLabel]);
end;

{ TClockLabel }
//on design time you may set active property to contral TTimer.Enabled;
constructor TClockLabel.Create(AOwner: TComponent);

begin
  inherited;
  FTimer:= TTimer.Create(self);
  FTimer.OnTimer:= UpdateClock;
  FTimer.Enabled:= true;
  //FTimer.Interval:= 1000;
end;



function TClockLabel.GetActive: Boolean;
begin
      Result:= FTimer.Enabled;
end;

procedure TClockLabel.SetActive(const Value: Boolean);
begin
     FTimer.Enabled:=Value;
end;

procedure TClockLabel.UpdateClock(Sender: Tobject);
begin
        //set Current time as Caption
        Caption:= TimeToStr(Time);
end;

end.
