{(*}
(*------------------------------------------------------------------------------
 Delphi Code formatter source code

The Original Code is CodeFormat.dpr, released April 2000.
The Initial Developer of the Original Code is Anthony Steele. 
Portions created by Anthony Steele are Copyright (C) 1999-2000 Anthony Steele.
All Rights Reserved. 
Contributor(s): Anthony Steele.

The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"). you may not use this file except in compliance with the License.
You may obtain a copy of the License at http://www.mozilla.org/NPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied.
See the License for the specific language governing rights and limitations
under the License.
------------------------------------------------------------------------------*)
{*)}

program CodeFormat;

{%ToDo 'CodeFormat.todo'}

uses
  Forms,
  fMain in 'UI\fMain.pas' {frmMain},
  fAbout in 'UI\fAbout.pas' {frmAboutBox},
  frFiles in 'Settings\frFiles.pas' {fFiles: TFrame},
  frObfuscateSettings in 'Settings\frObfuscateSettings.pas' {fObfuscateSettings: TFrame},
  frCapsSettings in 'Settings\frCapsSettings.pas' {fCapsSettings: TFrame},
  SettingsFrame in 'Settings\SettingsFrame.pas' {frSettingsFrame: TFrame},
  frReplace in 'Settings\frReplace.pas' {fReplace: TFrame},
  frExcludeFiles in 'Settings\frExcludeFiles.pas' {fExcludeFiles: TFrame},
  Converter in 'Converter.pas',
  ConvertTypes in 'Types\ConvertTypes.pas',
  Reader in 'ReadWrite\Reader.pas',
  Writer in 'ReadWrite\Writer.pas',
  TokenType in 'Types\TokenType.pas',
  Token in 'Types\Token.pas',
  WordMap in 'Types\WordMap.pas',
  TokenSource in 'Types\TokenSource.pas',
  Tokeniser in 'TokenCreation\Tokeniser.pas',
  Log in 'Utils\Log.pas',
  Pipeline in 'Types\Pipeline.pas',
  TokenProcessPipeline in 'Processors\TokenProcessPipeline.pas',
  Capitalisation in 'Processors\Capitalisation.pas',
  NoSpaceBefore in 'Processors\Spacing\NoSpaceBefore.pas',
  ReturnAfter in 'Processors\Spacing\ReturnAfter.pas',
  ReturnBefore in 'Processors\Spacing\ReturnBefore.pas',
  SingleSpaceAfter in 'Processors\Spacing\SingleSpaceAfter.pas',
  SingleSpaceBefore in 'Processors\Spacing\SingleSpaceBefore.pas',
  SpecificWordCaps in 'Processors\SpecificWordCaps.pas',
  TabToSpace in 'Processors\Spacing\TabToSpace.pas',
  TokenContext in 'TokenCreation\TokenContext.pas',
  IndentProcedures in 'Processors\Indent\IndentProcedures.pas',
  FixCase in 'Processors\Obfuscate\FixCase.pas',
  WhiteSpaceEater in 'Processors\Obfuscate\WhiteSpaceEater.pas',
  WhiteSpaceEater2 in 'Processors\Obfuscate\WhiteSpaceEater2.pas',
  CommentEater in 'Processors\Obfuscate\CommentEater.pas',
  LineUnbreaker in 'Processors\Obfuscate\LineUnbreaker.pas',
  LineRebreaker in 'Processors\Obfuscate\LineRebreaker.pas',
  RemoveFromUses in 'Processors\OnceOffs\RemoveFromUses.pas',
  ADOUsesClause in 'Processors\OnceOffs\ADOUsesClause.pas',
  Replace in 'Processors\Replace.pas',
  AlignAssign in 'Processors\Align\AlignAssign.pas',
  Position in 'Processors\Position.pas',
  AlignStatements in 'Processors\Align\AlignStatements.pas',
  AlignConst in 'Processors\Align\AlignConst.pas',
  AlignTypedef in 'Processors\Align\AlignTypedef.pas',
  AlignVars in 'Processors\Align\AlignVars.pas',
  Settings in 'Settings\Settings.pas',
  SetBase in 'Settings\SetBase.pas',
  SetObfuscate in 'Settings\SetObfuscate.pas',
  SetFile in 'Settings\SetFile.pas',
  SetCaps in 'Settings\SetCaps.pas',
  SetAnyWordCaps in 'Settings\SetAnyWordCaps.pas',
  SetClarify in 'Settings\SetClarify.pas',
  SetReplace in 'Settings\SetReplace.pas',
  SetLog in 'Settings\SetLog.pas',
  SetAlign in 'Settings\SetAlign.pas',
  SetIndent in 'Settings\SetIndent.pas',
  Indenter in 'Processors\Indent\Indenter.pas',
  IndentGlobals in 'Processors\Indent\IndentGlobals.pas',
  IndentClassDef in 'Processors\Indent\IndentClassDef.pas',
  TokenBareIndent in 'TokenCreation\TokenBareIndent.pas',
  NoSpaceAfter in 'Processors\Spacing\NoSpaceAfter.pas',
  IndentUsesClause in 'Processors\Indent\IndentUsesClause.pas',
  MozComment in 'Processors\OnceOffs\MozComment.pas',
  LineBreaker in 'Processors\LineBreaker.pas',
  IntList in 'Types\IntList.pas',
  CommentBreaker in 'TokenCreation\CommentBreaker.pas',
  JclStrings in '..\JCL\JclStrings.pas',
  JclBase in '..\JCL\JclBase.pas',
  JclFileUtils in '..\JCL\JclFileUtils.pas',
  JclWin32 in '..\JCL\JclWin32.pas',
  JclDateTime in '..\JCL\JclDateTime.pas',
  JclResources in '..\JCL\JclResources.pas',
  JclSysUtils in '..\JCL\JclSysUtils.pas',
  JclSysInfo in '..\JCL\JclSysInfo.pas',
  JclRegistry in '..\JCL\JclRegistry.pas',
  BlockStyles in 'Processors\Spacing\BlockStyles.pas',
  frClarify in 'Settings\frClarify.pas' {fClarify: TFrame},
  frBasicSettings in 'Settings\frBasicSettings.pas' {frBasic: TFrame},
  fSingleSettings in 'UI\fSingleSettings.pas' {frmSingleSettings},
  RemoveReturnsAfterBegin in 'Processors\Spacing\RemoveReturnsAfterBegin.pas',
  RemoveReturnsBeforeEnd in 'Processors\Spacing\RemoveReturnsBeforeEnd.pas',
  RemoveIndent in 'Processors\Obfuscate\RemoveIndent.pas',
  WarnRealType in 'Processors\Warnings\WarnRealType.pas',
  WarnDestroy in 'Processors\Warnings\WarnDestroy.pas',
  NoReturnBefore in 'Processors\Spacing\NoReturnBefore.pas',
  VCLFunctions in 'Components\VCLFunctions.pas',
  MemoEx in 'Components\MemoEx.pas',
  TypedEdit in 'Components\TypedEdit.pas',
  WarnCaseNoElse in 'Processors\Warnings\WarnCaseNoElse.pas',
  NoReturnAfter in 'Processors\Spacing\NoReturnAfter.pas',
  WarnEmptyBlock in 'Processors\Warnings\WarnEmptyBlock.pas';

{$R *.RES}

begin
  Application.Initialize;
  Application.CreateForm(TfrmMain, frmMain);
  Application.Run;
end.