unit DemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, ToolWin, ExtCtrls, MenuCust, DBCtrls, ImgList,
  StdActns, DBActns, ActnList;

type
  TMenuCustomizerDemoMainForm = class(TForm)
    MainMenu: TMainMenu;
    Help1: TMenuItem;
    About1: TMenuItem;
    MenuToolBarCheckBox: TCheckBox;
    ActionList: TActionList;
    DataSetCancel1: TDataSetCancel;
    DataSetDelete1: TDataSetDelete;
    DataSetEdit1: TDataSetEdit;
    DataSetFirst1: TDataSetFirst;
    DataSetInsert1: TDataSetInsert;
    DataSetLast1: TDataSetLast;
    DataSetNext1: TDataSetNext;
    DataSetPost1: TDataSetPost;
    DataSetPrior1: TDataSetPrior;
    DataSetRefresh1: TDataSetRefresh;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditPaste1: TEditPaste;
    WindowNew1: TWindowArrange;
    WindowCascade1: TWindowCascade;
    WindowClose1: TWindowClose;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    ImageList: TImageList;
    ControlBar: TControlBar;
    MenuBar: TToolBar;
    ToolButton1: TToolButton;
    DataSetBar: TToolBar;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    EditBar: TToolBar;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    WindowBar: TToolBar;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    DataSet1: TMenuItem;
    First1: TMenuItem;
    Prior1: TMenuItem;
    Next1: TMenuItem;
    Last1: TMenuItem;
    Insert1: TMenuItem;
    Delete1: TMenuItem;
    Edit1: TMenuItem;
    Post1: TMenuItem;
    Cancel1: TMenuItem;
    Refresh1: TMenuItem;
    Edit2: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    Window1: TMenuItem;
    Cascade1: TMenuItem;
    Arrange1: TMenuItem;
    TileHorizontally1: TMenuItem;
    TileVertically1: TMenuItem;
    Close1: TMenuItem;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    ToggleButton: TButton;
    HintLabel: TLabel;
    SaveMenuButton: TButton;
    LoadMenuButton: TButton;
    Bevel1: TBevel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ToolButton23: TToolButton;
    procedure About1Click(Sender: TObject);
    procedure MenuToolBarCheckBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToggleButtonClick(Sender: TObject);
    procedure ToolButton2StartDock(Sender: TObject;
      var DragObject: TDragDockObject);
    procedure ToolButton2EndDock(Sender, Target: TObject; X, Y: Integer);
    procedure DataSetBarDockOver(Sender: TObject; Source: TDragDockObject;
      X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure SaveMenuButtonClick(Sender: TObject);
    procedure LoadMenuButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FMenuCustomizer: TMenuCustomizer;
    FDockObject: TDragDockObject;
    procedure CheckToolBarSizes;
    procedure CheckMenuToolBar;
    procedure EndDock(Sender: TObject);
    procedure IsDockItem(Sender: TObject; MenuItem: TMenuItem;
      var IsDocking: Boolean);
    procedure CanDeleteItem(Sender: TObject; MenuItem: TMenuItem;
      var CanDelete: Boolean);
  end;

var
  MenuCustomizerDemoMainForm: TMenuCustomizerDemoMainForm;

implementation

uses AboutFrm;

const

  sMenuFileName = 'MenuDemo.mnu';

{$R *.DFM}

procedure TMenuCustomizerDemoMainForm.CheckToolBarSizes;
var
  I: Integer;
begin
  with ControlBar do
    for I := 0 to ControlCount - 1 do
      if (Controls[I] is TToolBar) and (Controls[I] <> MenuBar) then
        with Controls[I] as TToolBar do
          Width := ButtonWidth * ButtonCount + 2
end;

procedure TMenuCustomizerDemoMainForm.CheckMenuToolBar;

  function IsMenuItemButtonPresent(MenuItem: TMenuItem): Boolean;
  var
    I: Integer;
  begin
    Result := True;
    for I := 0 to MenuBar.ButtonCount - 1 do
      if MenuBar.Buttons[I].MenuItem = MenuItem then Exit;
    Result := False
  end;

var
  I: Integer;
begin
  if MenuToolBarCheckBox.Checked then
  begin
    with MenuBar do
    begin
      I := 0;
      while I < ButtonCount do
        if (Buttons[I].MenuItem = nil) or
          not (Buttons[I].MenuItem.Parent = MainMenu.Items) then
          Buttons[I].Free
        else
          Inc(I)
    end;
    with MainMenu.Items do
      for I := 0 to Count - 1 do
        if not IsMenuItemButtonPresent(Items[I]) then
          with TToolButton.Create(MenuBar) do
          begin
            Left := MenuBar.ButtonWidth * I;
            Parent := MenuBar;
            MenuItem := Items[I];
            Grouped := True
        end
  end
end;             

procedure TMenuCustomizerDemoMainForm.EndDock(Sender: TObject);
begin
  CheckToolBarSizes
end;

procedure TMenuCustomizerDemoMainForm.IsDockItem(Sender: TObject;
  MenuItem: TMenuItem; var IsDocking: Boolean);
begin
  IsDocking := (MenuItem <> Help1) and (MenuItem <> About1)
end;

procedure TMenuCustomizerDemoMainForm.CanDeleteItem(Sender: TObject;
  MenuItem: TMenuItem; var CanDelete: Boolean);
begin
  CanDelete := (MenuItem <> DataSet1) and (MenuItem <> Edit2) and
    (MenuItem <> Window1) and (MenuItem <> Help1)
end;

procedure TMenuCustomizerDemoMainForm.About1Click(Sender: TObject);
begin
  with TAbout.Create(Application) do
    try
      ShowModal
    finally
      Free
    end
end;

procedure TMenuCustomizerDemoMainForm.MenuToolBarCheckBoxClick(Sender: TObject);
var
  I: Integer;
begin
  if MenuToolBarCheckBox.Checked then
    with MenuBar, MainMenu do
    begin
      while ControlCount > 0 do Controls[0].Free;
      for I := 0 to Items.Count - 1 do
        with TToolButton.Create(MenuBar) do
        begin
          Parent := MenuBar;
          MenuItem := Items[I];
          Grouped := True
        end;
      Menu := nil;
      FMenuCustomizer.MenuBar := MenuBar;
      Visible := True
    end
    else
    begin
      FMenuCustomizer.MenuBar := nil;
      MenuBar.Visible := False;
      Menu := MainMenu
    end
end;

procedure TMenuCustomizerDemoMainForm.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  with ActionList do
    for I := 0 to ActionCount - 1 do
      (Actions[I] as TCustomAction).DisableIfNoHandler := False;
  FMenuCustomizer := TMenuCustomizer.Create(Self);
  with FMenuCustomizer do
  begin
    Menu := MainMenu;
    MenuBar := Self.MenuBar;
    OnEndDock := EndDock;
    OnIsDockItem := IsDockItem;
    OnCanDeleteItem := CanDeleteItem
  end;
  FDockObject := nil;
  CheckToolBarSizes
end;

procedure TMenuCustomizerDemoMainForm.ToggleButtonClick(Sender: TObject);

  procedure SetDragMode(Active: Boolean);
  var
    I, J: Integer;
  begin
    with ControlBar do
      for I := 0 to ControlCount - 1 do
        if (Controls[I] is TToolBar) and (Controls[I] <> MenuBar) then
          with Controls[I] as TToolBar do
            for J := 0 to ButtonCount - 1 do
              if Active then
                Buttons[J].DragMode := dmAutomatic
              else
                Buttons[J].DragMode := dmManual
  end;

begin
  with FMenuCustomizer do
  begin
    Active := not Active;
    MenuToolBarCheckBox.Enabled := not Active;
    if Active then
      ToggleButton.Caption := 'Stop customizing'
    else
      ToggleButton.Caption := 'Start customizing';
    SetDragMode(Active);
    HintLabel.Visible := Active
  end
end;

procedure TMenuCustomizerDemoMainForm.ToolButton2StartDock(Sender: TObject;
  var DragObject: TDragDockObject);
begin
  if (Sender <> nil) and (Sender is TToolButton) then
  begin
    FDockObject := TMenuDockObject.Create(Sender as TToolButton);
    DragObject := FDockObject
  end
end;

procedure TMenuCustomizerDemoMainForm.ToolButton2EndDock(Sender,
  Target: TObject; X, Y: Integer);
begin
  FDockObject.Free;
  FDockObject := nil
end;

procedure TMenuCustomizerDemoMainForm.DataSetBarDockOver(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
begin
  Accept := Source.Control is TToolButton
end;

procedure TMenuCustomizerDemoMainForm.SaveMenuButtonClick(Sender: TObject);
var
  F: TFileStream;
begin
  F := TFileStream.Create(sMenuFileName, fmCreate);
  try
    SaveMenuToStream(F, MainMenu)
  finally
    F.Free
  end;
  LoadMenuButton.Enabled := True
end;

procedure TMenuCustomizerDemoMainForm.LoadMenuButtonClick(Sender: TObject);
var
  F: TFileStream;
begin
  F := TFileStream.Create(sMenuFileName, fmOpenRead);
  try
    LoadMenuFromStream(F, MainMenu)
  finally
    F.Free  
  end;
  CheckMenuToolBar
end;

procedure TMenuCustomizerDemoMainForm.FormDestroy(Sender: TObject);
begin
  if FileExists(sMenuFileName) then DeleteFile(sMenuFileName)
end;

end.
