{
 ############################################################################
 ## FineComponents for Delphi 2/3/4/5 based on Graph64                     ##
 ##                                                                        ##
 ## Version -0.01 preview release                                          ##
 ##                                                                        ##
 ## Copyright (c)2000 Pavol Stugel                                         ##
 ## Homepage: www.graph64.miesto.sk                                        ##
 ## e-mail: pstugel@pobox.sk                                               ##
 ############################################################################

 Last updated: 12.September 2000

 **********************************************************************
 !!!THIS IS ONLY PREVIEW VERSION!!! You can send me your comment now!!!
 **********************************************************************
 !!!NOTE: IN NEXT RELEASE BUTTON WILL BE CLASS INSTEAD OF RECORD!!!!
 I'm still working on it.
 
 "Known Bugs":
    1.You must assign Images !!!!

 SK: - slovak language texts
 SK: vsetko sa mi nechce pisat v slovencine nakolko je vyklad jasny aj
     z anglictiny takze ospravedlnte znizenu kvalitu :-(. Ak by niekto
     niecomu nerozumel staci mailnut.


 Know styles in FinePanel:

 psMacOsX:  I only think that this is MacOsX design because I saw only one picture with
            ToolBar (IE 5). All buttons are in grayscaled, but disabled is less visible.
            Button under mouse is colored (I think :-).
 psGraph64: This is my idea. All buttons are colored instead disabled. When you move mouse to
            another button(s) fade effect is visible
 psExplorer:Classic stupid buttons like in IE 3.xx   (doesn't exists now)
 psNetscape:Same as Netscape 4.xx.                   (doesn't exists now)

}

unit FineComponents;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,
  ImgList, //for custom image list
  Graph64; //for bitmap effects


type
  TFinePanelStyle= (psNetscape, psExplorer,psGraph64,psMacOsX); //supported panel styles

type
  PFineButton= ^TFineButton;
  TFineButton= record
    Caption: string; //caption
    Separator: Boolean;  //if separator is true variables Caption,Index,Frame,Down,OnClick,Enabled are ignored
    OnClick: TNotifyEvent;
    Enabled: Boolean;

    SeparatorWidth,
    Index: Integer; //index to image
    Down: Boolean;  //clicked on image
    Frame: integer; // 10 full visible (active) 0-normal, this is for psGraph64
    Rect: TRect;
  end;

type
  TFinePanel= class(TGraphicControl)

  private
    FBackImage: TScreen64;  // this is temporary bitmap SK: ...
    FBitmap: TBitmap;       // Background image SK: pozadie

    LastButtonLeft: Integer;
    FOnPaint: TNotifyEvent;
    FCanUpdate,
    FShowCaptions,
    FMouseInside,           // Intrenal use only 
    FListMode: Boolean;     // List mode enabled/disabled

    FStyle: TFinePanelStyle;
    FButtonList: TList;

    FSeparatorWidth,
    FButtonHeight,
    FButtonWidth,
    FButtonUnderMouse: Integer;

    FImages: TCustomImageList;

    FTimer: TTimer;  //timer for fading buttons


    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;

  protected

    procedure WndProc(var Message: TMessage);override;
    procedure Paint; override;
    procedure UpdateMe;
    procedure SetBitmap( Value: TBitmap);
    procedure SetImages( Value: TCustomImageList);
    procedure SetButtonWidth( Value: Integer);
    procedure SetButtonHeight( Value: Integer);
    procedure SetListMode( Value: Boolean);
    procedure SetShowCaptions( Value: Boolean);
    function  ButtonOnPos( x,y: Integer): Integer;
    procedure PaintButton( Value: Integer;Buffer:TScreen64);
    procedure UpdateButtonsParams;
    procedure ButtonTimer(Sender: TObject);

    function  GetButton( Index: Integer): PFineButton;

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
    procedure AddButton( Butt: PFineButton);
    property Canvas;

    property Button[ index: Integer]: PFineButton read GetButton;

  published

    procedure BeginUpdate;
    procedure EndUpdate;

    property ButtonWidth:Integer read FButtonWidth write SetButtonWidth default 24;
    property ButtonHeight: Integer read FButtonHeight write SetButtonHeight default 32;
    property SeparatorWidth: Integer read FSeparatorWidth write FSeparatorWidth default 5;
    property Bitmap: TBitmap read FBitmap write SetBitmap;

    property List: Boolean read FListMode write SetListMode default false;
    property Style: TFinePanelStyle read FStyle write FStyle;
    property ShowCaptions: Boolean read FShowCaptions write SetShowCaptions;
    property Images: TCustomImageList read FImages write SetImages;

    property Align default alTop;
    property Anchors;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Visible;

//    property OnContextPopup;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property OnStartDock;
    property OnStartDrag;

  end;


procedure Register;

implementation

constructor TFinePanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [ csClickEvents, csCaptureMouse];
  Width := 200;
  Height:= 32;
  Align := alTop;
  FStyle := psGraph64;
  LastButtonLeft:= 0;  
  FButtonWidth:= 24;
  FButtonHeight:= 24;
  FButtonUnderMouse:= -1;
  FCanUpdate:= True;
  FBitmap := TBitmap.Create;
  FBitmap.PixelFormat:= Graphics.pf16bit;
  FTimer:= Nil;
  FBackImage:= TScreen64.Create(Canvas, Width, Height, pf16bit);
  FButtonList:= nil;
end;

destructor TFinePanel.Destroy;
var xx:Integer;
begin

{ Last minute code without testing :-( }
  If Assigned( FButtonList) then
  begin
    if FButtonList.Count>0 then
      for xx:=0 to FButtonList.Count-1 do
        FreeMem( Button[xx]);
    FButtonList.Free;
  end;

  if FTimer<>Nil then
    FTimer.Destroy;
  FBackImage.Destroy;
  FBitmap.Destroy;
  inherited Destroy;

end;

procedure TFinePanel.BeginUpdate;
begin
  FCanUpdate:= False;
end;

procedure TFinePanel.EndUpdate;
begin
  FCanUpdate:= True;
  UpdateMe;
  Paint;
end;

procedure TFinePanel.SetButtonWidth( Value: Integer);
begin
   FButtonWidth:= Value;
   UpdateButtonsParams;
   UpdateMe;
   Paint;
end;

procedure TFinePanel.SetButtonHeight( Value: Integer);
begin
   FButtonHeight:= Value;
   UpdateButtonsParams;   
   UpdateMe;
   Paint;
end;

procedure TFinePanel.SetBitmap( Value: TBitmap);
begin
  FBitmap.Assign(Value);
  if (Value=nil) then
  begin
    FBitmap.Width:= 1;
    FBitmap.Height:= 1;
  end;
  UpdateMe;
  Paint;
end;

procedure TFinePanel.SetImages( Value: TCustomImageList);
begin
  FImages := Value;
{  if FImages <> nil then
  begin
  end;}
  UpdateMe;
  Paint;
end;

procedure TFinePanel.SetListMode( Value: Boolean);
begin
  if Value=FListMode then exit; //nothing to change
  FListMode:= Value;
  UpdateMe;
  Paint;
end;

procedure TFinePanel.SetShowCaptions( Value: Boolean);
begin
  if Value=FShowCaptions then exit;
  FShowCaptions:= Value;
  UpdateMe;
  Paint; 
end;

procedure TFinePanel.AddButton( Butt: PFineButton);
begin
  if not Assigned( FButtonList) then
    FButtonList:= TList.Create;

  FButtonList.Add( Butt);
  UpdateButtonsParams;
  UpdateMe;
  Paint;
end;

procedure TFinePanel.UpdateButtonsParams;
var xx: Integer;
begin

  if (Assigned( FButtonList))and( FButtonList.Count>0) then
    begin
      LastButtonLeft:= 0;
      for xx:= 0 to FButtonList.Count-1 do
        with PFineButton(FButtonList.Items[xx])^ do
          begin
            Rect.Top:= 0;
            Frame:= 0;
            Rect.Bottom:= Rect.Top+ButtonHeight;
            Rect.Left:= LastButtonLeft;

            if Separator then
              begin
                Rect.Right:= Rect.Left+SeparatorWidth;
                Inc( LastButtonLeft, SeparatorWidth);
              end
            else
              begin
                Rect.Right:= Rect.Left+ButtonWidth;
                Inc( LastButtonLeft, ButtonWidth);
              end;

          end;
    end;
end;

function TFinePanel.GetButton( Index: Integer): PFineButton;
begin
  if (Assigned( FButtonList))and( Index<FButtonList.Count) then
  begin
    result:= FButtonList.Items[ Index];
  end else result:= nil;
end;

procedure TFinePanel.PaintButton( Value: Integer;Buffer:TScreen64);
var tx,ty: Integer;
begin

  with PFineButton(FButtonList.Items[Value])^ do
    if separator then
    with FBackImage.BackBuffer.Canvas do
    begin
      MoveTo( Rect.Left+(Rect.Right-Rect.Left) div 2, Rect.Top+2);
      LineTo( Rect.Left+(Rect.Right-Rect.Left) div 2, Rect.Bottom-2);
//      FBackImage.Rectangle( Rect.Left, Rect.Top, Rect.Right, Rect.Bottom, 0);
    end
    else
    with FBackImage do
    begin

      Buffer.ClearSurface( $8000); //stupid color
      Buffer.Transparent:= True;
      Buffer.TransparentColor:= $8000;

      tx:=0; ty:=0;
      if (Index<>-1)and(Assigned(FImages)) then  //draw icon
      begin
        ty:= (ButtonHeight - FImages.Height) div 2;

        if (not List) then
        begin
          tx:= (ButtonWidth- FImages.Width) div 2;        
          ty:= (ButtonHeight - (FImages.Height + Self.Canvas.TextHeight( Caption)) ) div 2;
        end;

        FImages.Draw( Buffer.BackBuffer.Canvas, Integer(Down)+tx, Integer(Down)+ty, Index, true); //draw image from stream
      end;

      if ShowCaptions then //draw captions ;-)
      begin
        Buffer.BackBuffer.Canvas.Brush.style:= bsClear;

        if List then
        begin
          inc( tx,  FImages.width);
          ty:= (ButtonHeight - Self.Canvas.TextHeight( Caption)) div 2;
        end
        else
        begin
          tx:= (ButtonWidth - Self.Canvas.TextWidth( Caption)) div 2;
          inc( ty, FImages.Height);
        end;  

        Buffer.BackBuffer.Canvas.TextOut( Integer( Down) + tx, Integer(Down) + ty, caption);

      end;

//       Buffer.Rectangle(0,0,Buffer.Width-1,Buffer.Height-1,0);
     case style of
       psMacOsX:
         begin
           if (FButtonUnderMouse<>Value)or(not Enabled) then
             Buffer.ConvertToGrayScale; //this use more cpu
             
           if Enabled then
             Draw(Rect.Left, Rect.Top, Buffer)
           else
//             DrawLens( Rect.Left, Rect.Top, Buffer);
             DrawBlend(Rect.Left, Rect.Top, Buffer,0.2,0.8);
         end;
       psGraph64:
         begin
         
           if Enabled then
             DrawBlend(Rect.Left, Rect.Top, Buffer, 0.07*frame+0.3,0.7-0.07*frame)
           else
           begin
             Buffer.ConvertToGrayScale;
             DrawBlend(Rect.Left, Rect.Top, Buffer,0.2,0.8);
           end;
//           if (FButtonUnderMouse<>Value)
         end;
     end; //end of case
//       Rectangle( Rect.Left, Rect.Top, Rect.Right, Rect.Bottom, 0);
    end;
//  end;


end;

procedure TFinePanel.UpdateMe;
var xx,yy: Integer;
    TempBitmap: TScreen64;
begin
  if not FCanUpdate then exit; //can't update now

  if (Width<>FBackImage.Width)or(Height<>FBackImage.Height) then
    FBackImage.SetSize( Width, Height);

  // draw background  
  if (FBitmap.Width>1)and(FBitmap.Height>1) then
  begin
    if (FBitmap.Height>0)and(FBitmap.Width>0) then
      for yy:= 0 to (Height div FBitmap.Height) do
        for xx:= 0 to (Width div FBitmap.Width) do
            FBackImage.BackBuffer.Canvas.Draw(xx*FBitmap.Width,yy*FBitmap.Height, FBitmap);
  end
  else
  with FBackImage.BackBuffer.Canvas do
  begin
    Pixels[0,0]:= Color;//clBtnFace;
    FBackImage.Bar(0,0, FBackImage.Width,FBackImage.Height, FBackImage.Pixels[0,0]);//FBackImage.WinColor( clBtnFace));
  end;

  /// paint buttons
  TempBitmap:= nil;
  if Assigned(FButtonList) then //allocate temporary button bitmap
  begin
    TempBitmap:= TScreen64.Create(ButtonWidth,ButtonHeight,pf16bit);
    TempBitmap.BackBuffer.Canvas.Font:= Self.Font;
  end;

  if Assigned(FButtonList) then  //if we have any buttons
  for xx:=0 to FButtonList.count-1 do
    PaintButton( xx, TempBitmap);

  if Assigned(TempBitmap) then TempBitmap.Destroy; //remove temporary bitmap from memory

end;

function TFinePanel.ButtonOnPos( x,y: Integer): Integer;
var xx:Integer;
    found: Boolean;
begin
  if Assigned(FButtonList) then
    begin
      result:= -1;
      found:= false;
      xx:= 0;
      while (xx<FButtonList.Count)and(not Found) do
        with Button[xx]^.Rect do
        begin
          if (x>Left)and(x<Right)and(y>Top)and(Y<Bottom) then
          begin
            Found:= true;
            result:= xx;
          end;
          inc( xx);
        end;

    end
  else
    result:= -1;

end;

procedure TFinePanel.ButtonTimer(Sender: TObject);
var xx: Integer;
    NeedRepaint: boolean;
begin
  NeedRepaint:= False;
  if Assigned(FButtonList)and( FButtonList.count>0)then
  for xx:= 0 to FButtonList.Count-1 do
  with Button[xx]^ do
  begin
    if xx<>FButtonUnderMouse then
    begin
      if frame>0 then
        begin
          NeedRepaint:= true;
          Dec( Frame);
        end;
    end;
  end;

  if NeedRepaint then
  begin
     UpdateMe;
     Paint;
  end;
  if (FButtonUnderMouse=-1)and(not NeedRepaint)and(not FMouseInside) then
  begin
    FTimer.Enabled:= false;
  end;  
end;

// system messages
procedure TFinePanel.CMMouseEnter(var Message: TMessage);
begin
  FMouseInside:=  True;
  if Style=psGraph64 then
  begin
    if FTimer=Nil then
    begin
      FTimer:= TTimer.Create( self);
      FTimer.Interval:= 50;
      FTimer.OnTimer:= ButtonTimer;
    end;
    FTimer.Enabled:= True;
  end;  
end;

procedure TFinePanel.CMMouseLeave(var Message: TMessage);
var i: Integer;
begin
  FMouseInside:= False;
  if (Assigned(FButtonList))and(FButtonList.Count>0) then
    for i:=0 to FButtonList.Count-1 do
    with Button[i]^ do
    begin
      Down:= False;
//      Frame:= 0;
    end;
  FButtonUnderMouse:= -1;
  UpdateMe;
  Paint;
  Inherited;

end;

procedure TFinePanel.WndProc(var Message: TMessage);
var Index:Integer;
begin
  if csDesigning in ComponentState then
  begin
    inherited WndProc(Message);
    exit;
  end;
  if (Message.Msg = WM_MOUSEMOVE){ and MouseCapture} then
  begin

//    FBackImage.Line(0,0, TWMMouse(Message).XPos,TWMMouse(Message).YPos,0);
    Index:= ButtonOnPos(TWMMouse(Message).XPos,TWMMouse(Message).YPos);
    if FButtonUnderMouse<>Index then
      begin
       FButtonUnderMouse:= Index;
       if Index<>-1 then
          Button[Index]^.Frame:= 10;
       UpdateMe;
       Paint;
      end; 

{    if Index<>-1 then
      Button[Index]^.Enabled:= false;}
{    cxy := FTrackWidth + (TWMMouse(Message).XPos - FTrackPos.X);
    ShortCircuit := False;
    if cxy < FTrackSection.FMinWidth then
    begin
      Dec(cxy, FTrackSection.FMinWidth);
      ShortCircuit := True;
    end;
    if cxy > FTrackSection.FMaxWidth then
    begin
      Dec(cxy, FTrackSection.FMaxWidth);
      ShortCircuit := True;
    end;
    SectionTrack(FTrackSection, cxy, tsTrackMove);
    if ShortCircuit then
      Dec(TWMMouse(Message).XPos, cxy);}
  end;
  
  inherited WndProc(Message);
end;

procedure TFinePanel.WMSize(var Message: TWMSize);
var
  R: TRect;
begin
// SK: neviem ale sem by obcas mohol vliest !! Ale nevlezie!!!!
//  inherited;
  R := ClientRect;
  UpdateMe;
//  MEssageDlg('Parchante',mtInformation,[mbOk],-1);
end;

procedure TFinePanel.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin

end;

procedure TFinePanel.WMLButtonDown(var Message: TWMLButtonDown);
var Index: Integer;
begin
//  if csDesigning in ComponentState then exit;
  Index:= ButtonOnPos( Message.XPos,Message.YPos);
  if Index<>-1 then
    if (Button[Index]^.Enabled)and(not Button[Index]^.Separator) then
      begin
        Button[Index]^.Down:= true;
        UpdateMe;
        Paint;
      end;
  Inherited
//  MessageDlg(Format('Mouse down at: %d,%d',[Message.XPos,Message.YPos]),mtInformation,[mbOk],-1);
end;

procedure TFinePanel.WMLButtonUp(var Message: TWMLButtonUp);
var i,Index: Integer;
    YesClick: Boolean;
begin
  Index:= ButtonOnPos( Message.XPos,Message.YPos);
  YesClick:= False;
  if Index<>-1 then
    if Button[Index]^.Down = true then
 //       MessageDlg( Format('Mouse click on: %d',[ Index]),mtInformation,[mbOk],-1);
        YesClick:= true;

  if (Assigned(FButtonList))and(FButtonList.Count>0) then
    for i:=0 to FButtonList.Count-1 do
      Button[i]^.Down:= False;

  UpdateMe;
  Paint;
  Inherited;
  if YesClick then
    if Assigned(Button[Index]^.OnClick) then Button[Index]^.OnClick( Self);
    
end;

procedure TFinePanel.Paint;
var i: Integer;
    {h,tx,ty: Integer;}
begin

  if not FCanUpdate then exit;

  Canvas.Font := Font;
  Canvas.Brush.Color := Color;
  if (Width<>FBackImage.Width)or(Height<>FBackImage.Height) then UpdateMe;
  Canvas.Draw(0,0,FBackImage.BackBuffer);

  if csDesigning in ComponentState then //show only in design time SK: zobrazi sa iba pocas vytvarania komponentu
    with Canvas do
    begin
      if Assigned(FBitmap)then
        pen.Style:= psDash
      else
        Pen.Style := psDot;//psDash;
        Pen.Color:= clWindowText;

      Brush.Style := bsClear;

      Rectangle(0, 0, Width, Height);
      Pen.Color:= clBackground;
      Pen.Style:= psDashDotDot;//, psDashDot, psDashDotDot, psClear, psInsideFrame);

      for i:= 0 to 12 do
      begin
//        h:= 0;//(Height - ButtonHeight) div 2;
        Rectangle( i*ButtonWidth, 0, (i+1)*ButtonWidth, ButtonHeight);
      end;
    end;
  if Assigned(FOnPaint) then FOnPaint(Self);
end;

procedure Register;
begin
  RegisterComponents('FineComponents', [TFinePanel]); //Add to new page
end;


end.
