program Tut_1_4;
// Tutorial 1.4
//   by
//    Sebastian Schaefer (grasmo@gmx.net)
//   basierend auf einem Beispiel von
//    Laurids K.H. Kirkeby (LKHK@get2net.dk)
//   und dem Turorial der
//    c't (Heise) 20/99 ab Seite 242
{

 Einfaches OpenGL Ausgabe Programm:
  - zeichnet eine Pyramide, die um 2 Achsen rotiert
  - Einbeziehung des Keyboards in das Programm :
    - 's' fuer Start und Stop der Rotation
    - 'Esc' fuer beenden des Programms
  - Benutzung einer DisplayList(dient zur Beschleunigung)

 BEMERKUNG:
  DisplayList sind sehr wichtig in der OpenGL-Welt. In ihr werden statische Objekte
  gespeichert, die sich zur Laufzeit nicht mehr verndern. Die gespeicherten Listen
  werden viel schneller gezeichnet. Ausserdem werden in den DisplayLists auch Texturen
  gespeichert und sind somit eine (soweit ich weiss die einzige elegante) Methode,
  mehrere Texturen zu benutzen, ausser sie jedesmal neu zu laden.

}
uses
  math,
  OpenGL,
  Glut,
  GLMaterial;

const
  MinX = -4;
  MaxX = 4;

  MinY = -4;
  MaxY = 4;

  MinZ = -10;//Wir schauen in die
  MaxZ = 4;
 //Konstanten fuer die ClipPlanes(ine etwa: Projektionsraender)


var
 Winkel : real = 0; //Gibt den Winkel der Rotation an
 Animation : Boolean = TRUE; // Flag fuer die Bewegung
 Pyramide : integer;  //Hier wird die Display List gespeichert
{$R *.RES}


function MachePyramide : integer; //bergibt die Displaylist
 var
  TmpList : GLuint;
begin
 TmpList := glGenLists(1);        //Erzeugt die List
 glNewList(TmpList, GL_COMPILE);  //Setzt die Parameter der neuen Liste (soll gleich compiliert werden
//Jetzt kommt das zu zeichnende:
  glBegin(GL_TRIANGLE_STRIP);
   glColor3f(1,0,0);
   glVertex3f(-1,0,1);
   glColor3f(0,1,0);
   glVertex3f(1,0,1);
   glColor3f(1,1,1);
   glVertex3f(0,1,0);
   glColor3f(0,0,1);
   glVertex3f(0,0,-1);
   glColor3f(1,0,0);
   glVertex3f(-1,0,1);
   glColor3f(0,1,0);
   glVertex3f(1,0,1);
  glEnd;
 glEndList;
 result:=TmpList; //bergibtdie Liste
end;

procedure CloseApp;
begin
 glutIdleFunc(nil);
 glutDestroyWindow(glutGetWindow);
 halt;
end;

//Setzt die Anfangsparameter
procedure SetGlParams;
begin
 glClearColor(0.0, 0.0, 0.0, 0.0);   //Hintergrundfarbe : schwarz(r,g,b)
 glShadeModel(GL_SMOOTH);            //Smooth Shading (alt: GL_FLAT)
 glEnable(GL_DEPTH_TEST);            //Wir zeichnen doch 3D, oder?

end;

procedure display;cdecl;
begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPushMatrix;
  glRotatef(Winkel,1,0.5,0);
   glCallList(Pyramide); //Ruft die DisplayList auf
 glPopMatrix;
 glutSwapBuffers;
end;

procedure Action; cdecl;
begin
 Winkel := Winkel + 1;
 if Winkel > 360 then
  Winkel := Winkel - 360;
 glutPostRedisplay;
end;

procedure resize(width, height: integer); cdecl;
begin
  glViewport(0, 0, GLsizei(width), GLsizei(height));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glOrtho(MinX,MaxX,MinY,MaxY,MinZ,MaxZ);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
end;

procedure KeyBoard(key : byte; x,y : integer); cdecl;
begin
 if key = 27 then //ScanCode fuer Esc
  CloseApp;
 if key = ord('s') then //ScanCode fuer 's'
  if Animation then
   begin
    Animation := FALSE;
    glutIdleFunc(nil);
   end
  else
   begin
    Animation := TRUE;
    glutIdleFunc(Action);
   end;
end;

procedure RightMouseMenu(Selected : integer); cdecl;
begin
 if Selected = 1 then
  begin
   glutIdleFunc(Action);
   Animation := TRUE;
  end;
 if Selected = 2 then
  begin
   glutIdleFunc(nil);
   Animation := FALSE;
  end;
 if Selected = 3 then
  CloseApp;
end;

procedure MakeMenu;
begin
 glutCreateMenu(RightMouseMenu);
 glutAddMenuEntry('Start Animation', 1);
 glutAddMenuEntry('Stop Animation', 2);
 glutAddMenuEntry('Ende', 3);
 glutAttachMenu(GLUT_RIGHT_BUTTON);
end;

begin
 InitOpenGL;
  if not(glutInit(SGI_LIB)) then glutInit(MS_LIB);
 glutInitDisplayMode(GLUT_DOUBLE or GLUT_RGBA);
 glutInitWindowSize(500, 500);
 glutInitWindowPosition(100, 100);
 glutCreateWindow(Pchar(ParamStr(0)));
 SetGlParams;

 glutDisplayFunc(display);
 glutReshapeFunc(resize);
 glutkeyboardFunc(keyboard);
 glutIdleFunc(Action);
 //Der Variablen wird die erzeugte Liste bergeben
 Pyramide := MachePyramide;
 MakeMenu;
 
 glutMainLoop;
end.
