program Tut_1_7;
// Tutorial 1.7
//   by
//    Sebastian Schaefer (grasmo@gmx.net)
//   basierend auf einem Beispiel von
//    Laurids K.H. Kirkeby (LKHK@get2net.dk)
//   und dem Turorial der
//    c't (Heise) 20/99 ab Seite 242
{

 Einfaches OpenGL Ausgabe Programm:
  - nutzt die Glut.dll zum Erstellen eines Fensters
  - zeichnet eine Pyramide, die um 2 Achsen rotiert
  - Einbeziehung des Keyboards in das Programm :
    - 's' fuer Start und Stop der Rotation
    - 'Esc' fuer beenden des Programms
  - Benutzung einer DisplayList(dient zur Beschleunigung)
  -TEXTUREN!!!!!

 Texturen werden mit hilfe der gltexture.dll geladen.
}
uses
  Windows,
  SysUtils,
  math,
  OpenGL,
  Glut,
  GLMaterial,
  glTexture;
  //Es werden zwar nicht alle Units bentigt, aber was solls

const
  MinX = -4;
  MaxX = 4;

  MinY = -4;
  MaxY = 4;

  MinZ = -10;//Wir schauen in die
  MaxZ = 4;
 //Konstanten fuer die ClipPlanes(ine etwa: Projektionsraender)
 Color = TRUE;

var
 Winkel : real = 0; //Gibt den Winkel der Rotation an
 Animation : Boolean = TRUE; // Flag fuer die Bewegung
 Pyramide : integer;  //Hier wird die Display List gespeichert
{$R *.RES}

procedure LoadTex(n : integer);
begin
if (n >= 1) and (n <= 6) then
 begin
  case n of
  1 : ReadTexture('tex\1.bmp');  //Hier wird die Textur geladen
  2 : ReadTexture('tex\2.bmp');
  3 : ReadTexture('tex\3.bmp');
  4 : ReadTexture('tex\4.bmp');
  5 : ReadTexture('tex\5.bmp');
  6 : ReadTexture('tex\6.bmp');
  end;                               //Die restlichen GL-Befehlen sind TexturParameter
  gltexparameteri(gl_texture_2d,gl_texture_wrap_s,gl_repeat);
  gltexparameteri(gl_texture_2d,gl_texture_wrap_t,gl_repeat);
  gltexparameteri(gl_texture_2d,gl_texture_mag_filter,GL_LINEAR);
  gltexparameteri(gl_texture_2d,gl_texture_min_filter,GL_LINEAR);
                                              //Statt GL_LINEAR geht auch GL_NEAREST
  gltexEnvi(gl_texture_env,gl_texture_env_mode,GL_DECAL);
 end;                                        //GL_DECAL bedeutet: die Textur aufkleben
end;

// Zeichnet die Sechs Seiten des Wrfels:
// - laden der Textur
// - zeichnen derSeite

// Um mehr als eine Textur zu laden, darf
// der Aufruf nicht in einem glBegin ... glEnd Block stehen
procedure DrawCube;
begin
  glBegin(GL_QUADS);
   glColor3f(1,1,1);
 glEnable(GL_TEXTURE_2D);
   LoadTex(1);                           //Erst wird die Textur geladen
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,1);                    //Hier wird die Texturcoordinate fr den Punkt oben festgelegt
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(3);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(6);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,-1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(0,-1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(4);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(5);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(2);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(-1,1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(-1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
  glDisable(GL_TEXTURE_2D);

end;

function MachePyramide : integer; //bergibt die Displaylist
 var
  TmpList : GLuint;
begin
 TmpList := glGenLists(1);        //Erzeugt die List
 glNewList(TmpList, GL_COMPILE);  //Setzt die Parameter der neuen Liste
  DrawCube;
 glEndList;
 result:=TmpList; //bergibtdie Liste
end;

procedure CloseApp;
begin
 glutIdleFunc(nil);
 glutDestroyWindow(glutGetWindow);
 halt;
end;

procedure SetGlParams;
begin
 glClearColor(0.0, 0.0, 0.0, 0.0);   //Hintergrundfarbe : schwarz(r,g,b)
 glShadeModel(GL_SMOOTH);            //Smooth Shading (alt: GL_FLAT)
 glEnable(GL_DEPTH_TEST);            //Wir zeichnen doch 3D, oder?
 glEnable(GL_LIGHTING);
end;

procedure display;cdecl;
begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPushMatrix;
  glRotatef(Winkel,1,0.5,0);
   glScalef(1.3, 1.3, 1.3);
   glCallList(Pyramide);
 glPopMatrix;
 glutSwapBuffers;
end;

procedure Action; cdecl;
begin
 Winkel := Winkel + 2;
 if Winkel > 360 then
  Winkel := Winkel - 360;
 glutPostRedisplay;
end;

procedure resize(width, height: integer); cdecl;
begin
  glViewport(0, 0, GLsizei(width), GLsizei(height));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glOrtho(MinX,MaxX,MinY,MaxY,MinZ,MaxZ);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
end;

procedure KeyBoard(key : byte; x,y : integer); cdecl;
begin
 if key = 27 then //ScanCode fuer Esc
  CloseApp;
 if key = ord('s') then //ScanCode fuer 's'
  if Animation then
   begin
    Animation := FALSE;
    glutIdleFunc(nil);
   end
  else
   begin
    Animation := TRUE;
    glutIdleFunc(Action);
   end;
end;

procedure RightMouseMenu(Selected : integer); cdecl;
begin
 if Selected = 1 then
  begin
   glutIdleFunc(Action);
   Animation := TRUE;
  end;
 if Selected = 2 then
  begin
   glutIdleFunc(nil);
   Animation := FALSE;
  end;
 if Selected = 3 then
  CloseApp;
end;

procedure MakeMenu;
begin
 glutCreateMenu(RightMouseMenu);
 glutAddMenuEntry('Start Animation', 1);
 glutAddMenuEntry('Stop Animation', 2);
 glutAddMenuEntry('Ende', 3);
 glutAttachMenu(GLUT_RIGHT_BUTTON);
end;

begin
 InitOpenGL;
  if not(glutInit(SGI_LIB)) then glutInit(MS_LIB);
 glutInitDisplayMode(GLUT_DOUBLE or GLUT_RGBA);
 glutInitWindowSize(500, 500);
 glutInitWindowPosition(100, 100);
 glutCreateWindow(Pchar(ParamStr(0)));
 SetGlParams;

 glutDisplayFunc(display);
 glutReshapeFunc(resize);
 glutkeyboardFunc(keyboard);
 glutIdleFunc(Action);
 Pyramide := MachePyramide;
 MakeMenu;
 
 glutMainLoop;
end.

