program Tut_1_8;
// Tutorial 1.8
//   by
//    Sebastian Schaefer (grasmo@gmx.net)
//   basierend auf einem Beispiel von
//    Laurids K.H. Kirkeby (LKHK@get2net.dk)
//   und dem Turorial der
//    c't (Heise) 20/99 ab Seite 242
{

 Einfaches OpenGL Ausgabe Programm:
  - nutzt die Glut.dll zum Erstellen eines Fensters
  - zeichnet einen Wuerfel( = 'Cube'), die um 2 Achsen rotiert
  - Einbeziehung des Keyboards in das Programm :
    - 's' fuer Start und Stop der Rotation
    - 'Esc' fuer beenden des Programms
  - Benutzung einer DisplayList(dient zur Beschleunigung)
  - 6 Texturen
  - Fullscreen in allen mglichen Auflsungen


}
uses
  Windows,
  SysUtils,
  classes,
  Forms,
  math,
  OpenGL,
  Glut,
  GLMaterial,
  glTexture;
  //Es werden zwar nicht alle Units bentigt, aber was solls

const
  MinX = -4;
  MaxX = 4;

  MinY = -4;
  MaxY = 4;

  MinZ = -10;//Wir schauen in die
  MaxZ = 4;
 //Konstanten fuer die ClipPlanes(ine etwa: Projektionsraender)
 Color = TRUE;

type

 TRes = record  //Wird zur Verwaltung der mglichen Auflsungen bentigt
  Width, Height, Bpp : integer;
 end;
 PRes = ^TRes;

var
 Winkel : real = 0; //Gibt den Winkel der Rotation an
 Animation : Boolean = TRUE; // Flag fuer die Bewegung
 Cube : integer;  //Hier wird die Display List gespeichert
 ResList : TList;                                  //Alle mglichen Auflsungen
 WinWidth, WinHeight, WinXPos, WinYPos : integer;  //Originale Wert
 OrigRes : TRes;                                   //Originale Auflsung
 DoFull : Boolean = FALSE;                         //FullscreenFlag I
 SetFull : Boolean = FALSE;                        //FullscreenFlag II

{$R *.RES}
//****************************************************
// Resolution-Zeug
//****************************************************

// Eintragen aller mglichen Auflsungen in ResList
procedure GetAllRes;
var i : integer;
    dm : TDEVMODE;
    Status : boolean;
    Depth : integer;

 procedure ToList(x, y, bpp : integer);
  var
   Res : PRes;
 begin
  New(RES);
  Res^.Width:= x;
  Res^.Height:= y;
  Res^.Bpp:= bpp;
  ResList.Add(Res);
 end;
begin

for i:=0 to 100 do
 begin
  Status:=EnumDisplaySettings(nil,i,dm);
  Depth:=dm.dmBitsPerPel;
  if ((Status=true)and(Depth>8)) then begin
   ToList(dm.dmPelsWidth,dm.dmPelsHeight,dm.dmBitsPerPel);
  end;
  if (Status=false) then break; // Keine weiteren Modi verfgbar -> Schleife abbrechen
 end;
end;

//Einstellen einer gewnschten Auflsung
procedure SetRes(x,y,bpp : integer);
var dm : TDEVMODE;
    mode,Status : boolean;
    i : integer;
begin
mode:=false;
for i:=0 to 100 do
 begin
  Status:=EnumDisplaySettings(nil,i,dm);
  if (Status=true) then
   begin
    if ((dm.dmBitsPerPel=bpp) and (dm.dmPelsWidth=x) and (dm.dmPelsHeight=y)) then
     begin
      ChangeDisplaySettings(dm,CDS_FULLSCREEN);
      mode:=true;
     end;
   end;
   if (mode=true) then break;
  end;
  if DoFull then
   begin
    glutFullscreen;
    SetFull :=  TRUE;
   end;
end;

//Prft, ob die Auflsung mglich ist
function ValidRes(x,y,bpp : integer) : Boolean;
var dm : TDEVMODE;
    mode,Status : boolean;
    i : integer;
begin
mode:=false;
for i:=0 to 100 do
 begin
  Status:=EnumDisplaySettings(nil,i,dm);
  if (Status=true) then
   begin
    if ((dm.dmBitsPerPel=bpp) and (dm.dmPelsWidth=x) and (dm.dmPelsHeight=y)) then
     begin
      mode:=true;
     end;
   end;
   if (mode=true) then break;
  end;
 ValidRes :=  Mode;
end;

//Stellt den in OrigRes gespeicherten Zustand wieder her
procedure RestoreDisplayMode;
var dm : TDeviceMode;
begin
 dm.dmPelsWidth := OrigRes.Width;
 dm.dmPelsHeight := OrigRes.Height;
 dm.dmBitsPerPel := OrigRes.bpp;
 ChangeDisplaySettings(dm,CDS_FULLSCREEN);
end;


procedure LoadTex(n : integer);
begin
if (n >= 1) and (n <= 6) then
 begin
  case n of
  1 : ReadTexture('tex\1.bmp');  //Hier wird die Textur geladen
  2 : ReadTexture('tex\2.bmp');
  3 : ReadTexture('tex\3.bmp');
  4 : ReadTexture('tex\4.bmp');
  5 : ReadTexture('tex\5.bmp');
  6 : ReadTexture('tex\6.bmp');
  end;                               //Die restlichen GL-Befehlen sind TexturParameter
  gltexparameteri(gl_texture_2d,gl_texture_wrap_s,gl_repeat);
  gltexparameteri(gl_texture_2d,gl_texture_wrap_t,gl_repeat);
  gltexparameteri(gl_texture_2d,gl_texture_mag_filter,GL_LINEAR);
  gltexparameteri(gl_texture_2d,gl_texture_min_filter,GL_LINEAR);
//  gltexEnvi(gl_texture_env,gl_texture_env_mode,GL_DECAL);
//Weil hier der Aufruf fehlt, wird die Textur nicht aufgeklebt, sondern "ueberblendet"
//ist die Textur weiss, wird die untere Farbe gezeigt. Bei schwarz sieht man die Textur.
 end;
end;

procedure DrawCube;
begin
  glBegin(GL_QUADS);
   glColor3f(1,1,1);
 glEnable(GL_TEXTURE_2D);
   LoadTex(1);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(3);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(6);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,-1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(0,-1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(4);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(5);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(0,0);
  glEnd;
  LoadTex(2);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(-1,1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(-1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
  glDisable(GL_TEXTURE_2D);

end;

function MacheCube : integer; //bergibt die Displaylist
 var
  TmpList : GLuint;
begin
 TmpList := glGenLists(1);        //Erzeugt die List
 glNewList(TmpList, GL_COMPILE);  //Setzt die Parameter der neuen Liste
  DrawCube;
 glEndList;
 result:=TmpList; //bergibtdie Liste
end;

procedure CloseApp;
begin
 RestoreDisplayMode;   //ACHTUNG <-- SEHR WICHTIG!!!!!!!!!!!!!!!!!!!!
 glutIdleFunc(nil);
 glutDestroyWindow(glutGetWindow);
 halt;
end;

procedure SetGlParams;
begin
 glClearColor(0.0, 0.0, 0.0, 0.0);   //Hintergrundfarbe : schwarz(r,g,b)
 glShadeModel(GL_SMOOTH);            //Smooth Shading (alt: GL_FLAT)
 glEnable(GL_DEPTH_TEST);            //Wir zeichnen doch 3D, oder?
// glEnable(GL_LIGHTING);
end;

procedure display;cdecl;
begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPushMatrix;
  glRotatef(Winkel,1,0.5,0);
   glScalef(1.3, 1.3, 1.3);
   glCallList(Cube);
 glPopMatrix;
 glutSwapBuffers;
 if SetFull then
  begin
   SetFull := FALSE;
   glViewport(0, 0, Screen.width, Screen.height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity;
   glOrtho(MinX,MaxX,MinY,MaxY,MinZ,MaxZ);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity;
  end;
end;

procedure Action; cdecl;
begin
 Winkel := Winkel + 2;
 if Winkel > 360 then
  Winkel := Winkel - 360;
 glutPostRedisplay;
end;

procedure resize(width, height: integer); cdecl;
begin
  glViewport(0, 0, GLsizei(width), GLsizei(height));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glOrtho(MinX,MaxX,MinY,MaxY,MinZ,MaxZ);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
end;

procedure KeyBoard(key : byte; x,y : integer); cdecl;
begin
 if key = 27 then //ScanCode fuer Esc
  CloseApp;
 if key = ord('s') then //ScanCode fuer 's'
  if Animation then
   begin
    Animation := FALSE;
    glutIdleFunc(nil);
   end
  else
   begin
    Animation := TRUE;
    glutIdleFunc(Action);
   end;
end;

procedure RightMouseMenu(Selected : integer); cdecl;
begin
 if Selected = 1 then
  begin
   glutIdleFunc(Action);
  end;
 if Selected = 2 then
  begin
   glutIdleFunc(nil);
  end;
 if Selected = 3 then
  CloseApp;
 if Selected = 4 then
  if not(DoFull) then
   begin
    doFull := not(DoFull);
    WinXPos := glutGet(GLUT_WINDOW_X);
    WinYPos := glutGet(GLUT_WINDOW_Y);
    WinWidth := glutGet(GLUT_WINDOW_WIDTH);
    WinHeight := glutGet(GLUT_WINDOW_HEIGHT);
    glutFullscreen;
    SetFull := TRUE;
   end
  else
   begin
    doFull := not(DoFull);
     if WinWidth > Screen.Width then WinWidth := Screen.Width;
     if WinHeight > Screen.Height then WinHeight := Screen.Height;
     if WinXPos > Screen.Width then WinXPos := trunc(Screen.Width/2);
     if WinYPos > Screen.Height then WinYPos := trunc(Screen.Height/2);
     glutReshapeWindow(WinWidth, WinHeight);
     glutPositionWindow(WinXPos, WinYPos);
   end;
end;

//Wenn Auswahl aus ResMouseMenu ==> ndern der Auflsung
procedure ResMouseMenu(Selected : integer); cdecl;
var
 Res : PRes;
begin
 New(Res);
 if Selected < ResList.Count then
  begin
   Res := ResList.Items[Selected];
   SetRes(Res^.Width, Res^.Height, Res^.Bpp);
  end;
end;

procedure MakeMenu;
var
 UnterMenu, i : integer;
 TmpStr : string;
 Res : PRes;
begin
 Untermenu := glutCreateMenu(ResMouseMenu);
  for i :=  0 to ResList.Count - 1 do
   begin
    Res := ResList.Items[i];
    TmpStr := inttostr(Res^.Width)+'x'+inttostr(Res^.Height)+'x'+inttostr(Res^.Bpp);
    glutAddMenuEntry(PChar(TmpStr), i);
   end;
 glutCreateMenu(RightMouseMenu);
 glutAddSubMenu('Resolution', UnterMenu);
 glutAddMenuEntry('Start Animation', 1);
 glutAddMenuEntry('Stop Animation', 2);
 glutAddMenuEntry('Fullscreen', 4);
 glutAddMenuEntry('Ende', 3);
 glutAttachMenu(GLUT_RIGHT_BUTTON);
end;

begin
 InitOpenGL;
  if not(glutInit(SGI_LIB)) then glutInit(MS_LIB);
 glutInitDisplayMode(GLUT_DOUBLE or GLUT_RGBA);
 glutInitWindowSize(500, 500);
 glutInitWindowPosition(100, 100);
 glutCreateWindow(Pchar(ParamStr(0)));
 SetGlParams;

 glutDisplayFunc(display);
 glutReshapeFunc(resize);
 glutkeyboardFunc(keyboard);
 glutIdleFunc(Action);
 Cube := MacheCube;

//Auflsung
 ResList := TList.Create;
 GetAllRes;

 MakeMenu;
 
 glutMainLoop;
end.

