program Tut_1_9;
// Test_1
//   by
//    Sebastian Schaefer (grasmo@gmx.net)
//   basierend auf einem Beispiel von
//    Laurids K.H. Kirkeby (LKHK@get2net.dk)
//   und dem Turorial der
//    c't (Heise) 20/99 ab Seite 242
{
Wir haben hier einen Wuerfel, der an eine Ebene gespiegelt wird.
Das ganze dreht sich um die y-Achse.
Die Kamera ist nach hinten und oben versetzt und schaut schrg von oben auf das
Geschehen.

gluLookAt(eyex, eyey, eyez, camerax, cameray, cameraz, upx, upy, upz)

 eye:    wo wir uns befinden: x, y, z
 camera: wohin schauen wir: x, y, z
 up:     der UP-Vektor

}
uses
  math,
  OpenGL,
  Glut,
  GLMaterial,
  glTexture;

//Es werden zwar nicht alle Units bentigt, aber was solls

const
  MinX = -4;
  MaxX = 4;

  MinY = -4;
  MaxY = 4;

  MinZ = -10;//Wir schauen in die
  MaxZ = 4;
 //Konstanten fuer die ClipPlanes(ine etwa: Projektionsraender)
 Color = TRUE;

var
 Winkel : real = 0; //Gibt den Winkel der Rotation des Wuerfels an
 mw : real = 0; //Gibt den Winkel der Rotation um die y-Achse an
 Animation : Boolean = TRUE; // Flag fuer die Bewegung
 Cube, InvCube : integer;  //Hier wird die Display List gespeichert
 sintab: Array[0..360] of real;   //Sinus und Cosinus Tabelle
 costab: Array[0..360] of real;   // ==> damit es schneller geht

{$R *.RES}

procedure LoadTex(n : integer);
begin
if (n >= 1) and (n <= 6) then
 begin
  case n of
  1 : ReadTexture('tex\1.bmp');  //Hier wird die Textur geladen
  2 : ReadTexture('tex\2.bmp');
  3 : ReadTexture('tex\3.bmp');
  4 : ReadTexture('tex\4.bmp');
  5 : ReadTexture('tex\5.bmp');
  6 : ReadTexture('tex\6.bmp');
  end;                               //Die restlichen GL-Befehlen sind TexturParameter
  gltexparameteri(gl_texture_2d,gl_texture_wrap_s,gl_repeat);
  gltexparameteri(gl_texture_2d,gl_texture_wrap_t,gl_repeat);
  gltexparameteri(gl_texture_2d,gl_texture_mag_filter,GL_NEAREST);
  gltexparameteri(gl_texture_2d,gl_texture_min_filter,GL_NEAREST);
  gltexEnvi(gl_texture_env,gl_texture_env_mode,GL_DECAL);
 end;
end;

procedure DrawCube;
begin
  glBegin(GL_QUADS);
   glColor3f(1,1,1);
// glEnable(GL_TEXTURE_2D);
//   LoadTex(1);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(3);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(6);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,-1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(0,-1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(4);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(5);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(2);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,-1);
   glTexCoord2f(-1,1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,1);
   glTexCoord2f(-1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
//  glDisable(GL_TEXTURE_2D);
end;

function MacheCube : integer; //bergibt die Displaylist
 var
  TmpList : GLuint;
begin
 TmpList := glGenLists(1);        //Erzeugt die List
 glNewList(TmpList, GL_COMPILE);  //Setzt die Parameter der neuen Liste
  DrawCube;
 glEndList;
 result:=TmpList; //bergibtdie Liste
end;

procedure DrawInvCube;
begin
  glBegin(GL_QUADS);
   glColor3f(1,1,1);
// glEnable(GL_TEXTURE_2D);
//   LoadTex(1);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(3);
  glBegin(GL_QUADS);
  glColor3f(1,1,-1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,-1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(6);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,1);
   glTexCoord2f(1,-1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,1);
   glTexCoord2f(0,-1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(4);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(2);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(0,0,0);
   glVertex3f(-1,1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(0,1,1);
   glVertex3f(1,1,1);
   glTexCoord2f(1,1);
   if Color then glColor3f(0,1,0);
   glVertex3f(1,1,-1);
   glTexCoord2f(1,0);
   if Color then glColor3f(0,0,1);
   glVertex3f(-1,1,-1);
   glTexCoord2f(0,0);
  glEnd;
//  LoadTex(5);
  glBegin(GL_QUADS);
  glColor3f(1,1,1);
   if Color then glColor3f(1,0,1);
   glVertex3f(-1,-1,1);
   glTexCoord2f(0,1);
   if Color then glColor3f(1,1,1);
   glVertex3f(1,-1,1);
   glTexCoord2f(-1,1);
   if Color then glColor3f(1,1,0);
   glVertex3f(1,-1,-1);
   glTexCoord2f(-1,0);
   if Color then glColor3f(1,0,0);
   glVertex3f(-1,-1,-1);
   glTexCoord2f(0,0);
  glEnd;
//  glDisable(GL_TEXTURE_2D);
end;

function MacheInvCube : integer; //bergibt die Displaylist
 var
  TmpList : GLuint;
begin
 TmpList := glGenLists(1);        //Erzeugt die List
 glNewList(TmpList, GL_COMPILE);  //Setzt die Parameter der neuen Liste
  DrawInvCube;
 glEndList;
 result:=TmpList; //bergibtdie Liste
end;

procedure CloseApp;
begin
 glutIdleFunc(nil);
 glutDestroyWindow(glutGetWindow);
 halt;
end;

procedure SetGlParams;
begin
 glClearColor(0.0, 0.0, 0.0, 0.0);   //Hintergrundfarbe : schwarz(r,g,b)
 glShadeModel(GL_FLAT);            //Smooth Shading (alt: GL_FLAT)
 glEnable(GL_DEPTH_TEST);            //Wir zeichnen doch 3D, oder?
end;

procedure display;cdecl;
begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

 glPushMatrix;
//Szene umdrehen (wegen dem Alphablending)
  glrotatef(180, 0, 0, 1);
//Fr die Rotation: rotate(cos(alpha)*d, 0,sin(alpha)*d) ==> um die y-Achse mit Abst. d
  gltranslatef(0,0,-4-(sintab[trunc(mw)]*4));
  gltranslatef((costab[trunc(mw)]*4), 0, 0);

//Erstmal der inverse Cubus
  glPushMatrix;
   gltranslatef(0,3,0);
   glRotatef(Winkel,0,0.5,-1);
   glRotatef(180, 1,0,0);
   glScalef(1.3, 1.3, 1.3);
    glCallList(InvCube);
  glPopMatrix;

//Die Spiegelflche
  glPushMatrix;
   glScalef(3.5, 0.1, 3.5);
   glEnable(GL_BLEND);
//Jetzt das Blending
   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   glColor4f(1.0, 1.0, 1.0, 0.6);
    glutSolidCube(3.0);
   glDisable(GL_BLEND);
  glPopMatrix;

//Der richtige Wrfel
  glPushMatrix;
   gltranslatef(0,-3,0);
   glRotatef(Winkel,0,0.5,1);
   glScalef(1.3, 1.3, 1.3);
    glCallList(Cube);
  glPopMatrix;
 glPopMatrix;

//und zeigen, bitte
 glutSwapBuffers;
end;

procedure Action; cdecl;
begin
 Winkel := Winkel + 1;
 if Winkel > 360 then
  Winkel := Winkel - 360;
 mw := mw + 0.5;
 if mw > 360 then
  mw := mw - 360;
 glutPostRedisplay;
end;

procedure resize(width, height: integer); cdecl;
begin
  glViewport(0, 0, GLsizei(width), GLsizei(height));
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(60,width/height,1, 100);
//Hier der Befehl fr die Kamera
  gluLookAt(0,30,13, 0,0,0, 0,1,0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
end;

procedure KeyBoard(key : byte; x,y : integer); cdecl;
begin
 if key = 27 then //ScanCode fuer Esc
  CloseApp;
 if key = ord('s') then //ScanCode fuer 's'
  if Animation then
   begin
    Animation := FALSE;
    glutIdleFunc(nil);
   end
  else
   begin
    Animation := TRUE;
    glutIdleFunc(Action);
   end;
end;

procedure RightMouseMenu(Selected : integer); cdecl;
begin
 if Selected = 1 then
  begin
   glutIdleFunc(Action);
  end;
 if Selected = 2 then
  begin
   glutIdleFunc(nil);
  end;
 if Selected = 3 then
  CloseApp;
end;

procedure MakeMenu;
begin
 glutCreateMenu(RightMouseMenu);
 glutAddMenuEntry('Start Animation', 1);
 glutAddMenuEntry('Stop Animation', 2);
 glutAddMenuEntry('Ende', 3);
 glutAttachMenu(GLUT_RIGHT_BUTTON);
end;

procedure init;
 var
    i: integer;
begin
 for i :=  0 to 360 do
  begin
   sintab[i] := sin(i*3.141/180);
   costab[i] := cos(i*3.141/180);
  end;
end;

begin
 InitOpenGL;
 if not(glutInit(MS_LIB)) then  if not(glutInit(SGI_LIB)) then glutInit(MS_LIB);
 glutInitDisplayMode(GLUT_DOUBLE or GLUT_RGBA);
 glutInitWindowSize(320, 240);
 glutInitWindowPosition(100, 100);
 glutCreateWindow(Pchar(ParamStr(0)));
 SetGlParams;
 glutDisplayFunc(display);
 glutReshapeFunc(resize);
 glutkeyboardFunc(keyboard);
 glutIdleFunc(Action);
 Cube := MacheCube;
 InvCube := MacheInvCube;

 MakeMenu;
 Init;

 glutMainLoop;
end.

