unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBClient, DCOMServer_TLB, ActnList;

type
  TDataModule2 = class(TDataModule)
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    ActionList1: TActionList;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    procedure Action1Update(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure Action2Execute(Sender: TObject);
    procedure Action3Update(Sender: TObject);
    procedure Action3Execute(Sender: TObject);
  private
    FComputerName: string;
    function GetMyServer: IMyServer;
    { Private declarations }
  public
    { Public declarations }
    property ComputerName: string read FComputerName write FComputerName;
    property MyServer: IMyServer read GetMyServer;
  end;

var
  DataModule2: TDataModule2;

implementation

{$R *.DFM}

{ TDataModule2 }

function TDataModule2.GetMyServer: IMyServer;
begin
  Result := CoMyServer.CreateRemote(FComputerName);
end;

procedure TDataModule2.Action1Update(Sender: TObject);
begin
  (Sender as TAction).Enabled := (ClientDataSet1.State in dsEditModes) or
    (ClientDataSet1.ChangeCount > 0);
end;

procedure TDataModule2.Action1Execute(Sender: TObject);
begin
  if not ClientDataSet1.Reconcile(
    MyServer.ApplyDepartmentUpdates(ClientDataSet1.Delta)) then
    ShowMessage('Error was detected.');
end;

procedure TDataModule2.Action2Execute(Sender: TObject);
begin
  ClientDataSet1.CancelUpdates;
end;

procedure TDataModule2.Action3Update(Sender: TObject);
begin
  (Sender as TAction).Enabled := not (
    (ClientDataSet1.State in dsEditModes) or
    (ClientDataSet1.ChangeCount > 0));
end;

procedure TDataModule2.Action3Execute(Sender: TObject);
begin
  ClientDataSet1.Data := MyServer.GetDepartments;
end;

end.
