unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, Db, DBClient;

type
  TDataModule2 = class(TDataModule)
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    ClientSocket1: TClientSocket;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadDepartments(const Address: string);
  end;

var
  DataModule2: TDataModule2;

implementation

{$R *.DFM}

{ TDataModule2 }

procedure TDataModule2.LoadDepartments(const Address: string);
var
  DataPacket: Pointer;
  PacketStream: TStream;
  Stream: TWinSocketStream;
  Buffer: array [0..25] of Char;
  StreamSize: Integer;
begin
  // Connect to the server and execute GetDepartment request
  ClientSocket1.Address := Address;
  ClientSocket1.Open;
  try
    // Create the communication stream
    Stream := TWinSocketStream.Create(ClientSocket1.Socket, 10000);
    try
      FillChar(Buffer, SizeOf(Buffer), 0);
      Buffer := 'GetDepartments';
      // Send request for departments
      Stream.Write(Buffer, SizeOf(Buffer));
      if Stream.WaitForData(20000) then
      begin
        // Read the size of the departments data packet
        Stream.Read(StreamSize, SizeOf(StreamSize));
        if Stream.WaitForData(10000) then
        begin
          PacketStream := TMemoryStream.Create;
          try
            // Read the data packet
            DataPacket := AllocMem(StreamSize);
            try
              Stream.Read(DataPacket^, StreamSize);
              PacketStream.Write(DataPacket^, StreamSize);
            finally
              FreeMem(DataPacket);
            end;
            // Load the data packet into the client data set
            PacketStream.Position := 0;
            ClientDataSet1.LoadFromStream(PacketStream);
          finally
            PacketStream.Free;
          end;
        end;
      end;
    finally
      Stream.Free;
    end;
  finally
    ClientSocket1.Close;
  end;
end;

end.
