unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Provider, BdeProv, ScktComp, SyncObjs, ActiveX, DBClient;

type
  TDataModule2 = class(TDataModule)
    Session1: TSession;
    Database1: TDatabase;
    Query1: TQuery;
    Provider1: TProvider;
    ServerSocket1: TServerSocket;
    ClientDataSet1: TClientDataSet;
    procedure DataModule2Destroy(Sender: TObject);
    procedure DataModule2Create(Sender: TObject);
    procedure ServerSocket1GetThread(Sender: TObject;
      ClientSocket: TServerClientWinSocket;
      var SocketThread: TServerClientThread);
  private
    { Private declarations }
    FCSect: TCriticalSection;
  public
    { Public declarations }
  end;

  TMyServerThread = class(TServerClientThread)
    procedure ClientExecute; override;
  end;

var
  DataModule2: TDataModule2;

implementation

{$R *.DFM}

{ TDataModule2 }

procedure TDataModule2.DataModule2Create(Sender: TObject);
begin
  FCSect := TCriticalSection.Create;
end;

procedure TDataModule2.DataModule2Destroy(Sender: TObject);
begin
  FCSect.Free;
end;

procedure TDataModule2.ServerSocket1GetThread(Sender: TObject;
  ClientSocket: TServerClientWinSocket;
  var SocketThread: TServerClientThread);
begin
  SocketThread := TMyServerThread.Create(False, ClientSocket);
end;

{ TMyServerThread }

procedure TMyServerThread.ClientExecute;
var
  Stream: TWinSocketStream;
  Buffer: array [0..25] of Char;
  PacketStream: TStream;
  DataPacket: Pointer;
  StreamSize: Integer;
begin
  // Initialize COM library for this thread
  CoInitialize(nil);
  try
    // Make sure connection is active
    while not Terminated and ClientSocket.Connected do
    begin
      try
        Stream := TWinSocketStream.Create(ClientSocket, 10000);
        try
          // Prepare request buffer
          FillChar(Buffer, SizeOf(Buffer), 0);
          // Wait 10 seconds until client data will be available
          if Stream.WaitForData(10000) then
          begin
            Stream.Read(Buffer, SizeOf(Buffer));
            if Buffer = 'GetDepartments' then
            begin
              // Create data packet for the client application
              PacketStream := TMemoryStream.Create;
              try
                // Make sure we are the only thread, which is working
                // with DataModule now
                DataModule2.FCSect.Enter;
                try
                  // Create data packet
                  DataModule2.ClientDataSet1.Open;
                  try
                    // Save data packet to the temporary stream
                    DataModule2.ClientDataSet1.SaveToStream(PacketStream);
                  finally
                    // Destroy data packet
                    DataModule2.ClientDataSet1.Close;
                  end;
                finally
                  // Let other threads to process their requests
                  DataModule2.FCSect.Leave;
                end;
                StreamSize := PacketStream.Size;
                // Write the size of the data packet
                Stream.Write(StreamSize, SizeOf(StreamSize));
                // Write the data packet into the stream
                DataPacket := AllocMem(StreamSize);
                try
                  PacketStream.Position := 0;
                  PacketStream.Read(DataPacket^, StreamSize);
                  Stream.Write(DataPacket^, StreamSize);
                finally
                  FreeMem(DataPacket);
                end;
              finally
                PacketStream.Free;
                Terminate;
              end;
            end else
            if Buffer = 'ApplyDepartmentUpdates' then
            begin
              // Handle ApplyUpdates request from the client in this place  
            end;
          end else
            ClientSocket.Close;
        finally
          Stream.Free;
        end;
      except
        HandleException;
      end;
    end;
  finally
    // Uninitialize COM library in this thread
    CoUninitialize;
  end;
end;

end.
