unit RemoveReturnsAfterBegin;

{ AFS 7 May 2K
  Processor to correct what is IMHO a commeon aethetic failing:
  blank lines after a block begin (see also RemoveReturnsBeforeEnd.pas)
  they are unnecessary and do not contribute to readability

  If you disagree, then turn it off
}

interface

uses Token, TokenSource;

type 
  TRemoveReturnsAfterBegin = class(TBufferedTokenProcessor)
  private
  protected
    function GetIsEnabled: boolean; override;
    function IsTokenInContext(const pt: TToken): boolean; override;
    function OnProcessToken(const pt: TToken): TToken; override;
  public

  end;

implementation

uses WordMap, TokenType;

{ TRemoveReturnsAfterBegin }

function TRemoveReturnsAfterBegin.GetIsEnabled: boolean;
begin
  Result := (not Settings.Obfuscate.Enabled) and Settings.Clarify.RemoveReturns;
end;

function TRemoveReturnsAfterBegin.IsTokenInContext(const pt: TToken): boolean;
begin
  Result := (pt.Word = wBegin) and (pt.ProcedureSection = psProcedureBody);
end;

function TRemoveReturnsAfterBegin.OnProcessToken(const pt: TToken): TToken;
var
  liLoop, liMax: integer;
  ptNext:        TToken;
  lbFirstReturn: boolean;
begin
  Result := pt;

  { find the index of the next solid token }
  liMax  := 0;
  ptNext := BufferTokens(liMax);
  while ptNext.TokenType in [ttWhiteSpace, ttReturn] do
  begin
    inc(liMax);
    ptNext := BufferTokens(liMax);
  end;

  lbFirstReturn := True;
  { remove all returns up to that point (except one) }
  for liLoop := liMax - 1 downto 0 do
  begin
    ptNext := BufferTokens(liLoop);
    if (ptNext.TokenType = ttReturn) then
    begin
      if (not lbFirstReturn) then
        RemoveBufferToken(liLoop);
      lbFirstReturn := False;
    end;
  end;
end;

end.