unit WarnRealType;

{ AFS 13 May 2K
 The first and simplest warner
}

interface

uses TokenType, Token, TokenSource;

type 
  TWarnRealType = class(TTokenProcessor)
  private
  protected
    function GetIsEnabled: boolean; override;
    function OnProcessToken(const pt: TToken): TToken; override;

  public

  end;

implementation

uses
    { delphi } SysUtils,
    { local } WordMap;

{ TWarnRealType }

function TWarnRealType.GetIsEnabled: boolean;
begin
  Result := (not Settings.Obfuscate.Enabled) and Settings.Clarify.Warnings;
end;

function TWarnRealType.OnProcessToken(const pt: TToken): TToken;
const
  REAL_WARNING = 'These types are obsolete and are seldom usefull. ' +
    'See the help for details';
begin
  Result := pt;

  if not (pt.DeclarationSection = dsVar) then
    exit;

  { see your help on 'real' for details.
   I don't know any reason to prefer these types to 'Double'

   If the code was orignally Delphi V1, then it may be better of as "Currency"
   }

  if pt.Word = wReal then
  begin
    Log.LogWarning(FilePlace(pt) + 'Real type used');
    Log.LogWarning(REAL_WARNING);
    Log.EmptyLine;
  end
  else if pt.Word = wReal48 then
  begin
    Log.LogWarning(FilePlace(pt) + 'Real48 type used');
    Log.LogWarning(REAL_WARNING);
    Log.EmptyLine;
  end;
end;

end.