unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Db, DBClient, Provider, BdeProv, ActnList;

type
  TDataModule2 = class(TDataModule)
    Database1: TDatabase;
    Query1: TQuery;
    Provider1: TProvider;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    ActionList1: TActionList;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    procedure Action1Update(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure Action2Execute(Sender: TObject);
    procedure Action3Execute(Sender: TObject);
    procedure ClientDataSet1ReconcileError(DataSet: TClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataModule2: TDataModule2;

implementation

uses Unit3;

{$R *.DFM}

procedure TDataModule2.Action1Update(Sender: TObject);
begin
  (Sender as TAction).Enabled :=
    (ClientDataSet1.State in dsEditModes) or
    (ClientDataSet1.ChangeCount > 0);
end;

procedure TDataModule2.Action1Execute(Sender: TObject);
begin
  if ClientDataSet1.ApplyUpdates(0) > 0 then
    raise Exception.Create('Error(s) was detected.');
  ClientDataSet1.UpdateCursorPos;
  ClientDataSet1.Resync([]);
end;

procedure TDataModule2.Action2Execute(Sender: TObject);
begin
  ClientDataSet1.CancelUpdates;
end;

procedure TDataModule2.Action3Execute(Sender: TObject);
begin
  ClientDataSet1.UndoLastChange(True);
end;

procedure TDataModule2.ClientDataSet1ReconcileError(
  DataSet: TClientDataSet; E: EReconcileError;
  UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(DataSet, UpdateKind, E);
end;

end.
