{(*}
(*------------------------------------------------------------------------------
 Delphi Code formatter source code 

The Original Code is SetCaps.pas, released April 2000.
The Initial Developer of the Original Code is Anthony Steele. 
Portions created by Anthony Steele are Copyright (C) 1999-2000 Anthony Steele.
All Rights Reserved. 
Contributor(s): Anthony Steele. 

The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"). you may not use this file except in compliance with the License.
You may obtain a copy of the License at http://www.mozilla.org/NPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied.
See the License for the specific language governing rights and limitations 
under the License.
------------------------------------------------------------------------------*)
{*)}

unit SetCaps;

{ settings to do with capitalisation
  AFS 29 Dec 1999
}

interface

uses SetBase, TokenType;

type

  TSetCaps = class(TSetBase)
  private

    fbEnabled: boolean;
    feReservedWords, feOperators,
    feDirectives, feConstants,
    feTypes: TCapitalisationType;

  protected
  public
    procedure Read; override;
    procedure Write; override;

    constructor Create;

    property Enabled: boolean read fbEnabled write fbEnabled;

    property ReservedWords: TCapitalisationType read feReservedWords write feReservedWords;

    property Operators: TCapitalisationType read feOperators write feOperators;
    property Directives: TCapitalisationType read feDirectives write feDirectives;
    property Constants: TCapitalisationType read feConstants write feConstants;
    property Types: TCapitalisationType read feTypes write feTypes;

  end;


implementation

const
  REG_ENABLED    = 'Enabled';
  REG_RESERVED_WORDS = 'ReservedWords';
  REG_OPERATORS  = 'Operators';
  REG_DIRECTIVES = 'Directives';
  REG_CONSTANTS  = 'Constants';
  REG_TYPES      = 'Types';

  { TSetCaps }

constructor TSetCaps.Create;
begin
  inherited;
  SetSection('Capitalisation');
end;

procedure TSetCaps.Read;
begin
  fbEnabled := ReadItem(REG_ENABLED, True);

  feReservedWords := ReadItem(REG_RESERVED_WORDS, ctLower);
  feOperators     := ReadItem(REG_OPERATORS, ctLower);
  feDirectives    := ReadItem(REG_DIRECTIVES, ctLower);
  feConstants     := ReadItem(REG_CONSTANTS, ctLower);
  feTypes         := ReadItem(Reg_TYPES, ctLower);
end;

procedure TSetCaps.Write;
begin
  WriteItem(REG_ENABLED, fbEnabled);

  WriteItem(REG_RESERVED_WORDS, feReservedWords);
  WriteItem(REG_OPERATORS, feOperators);
  WriteItem(REG_DIRECTIVES, feDirectives);
  WriteItem(REG_CONSTANTS, feConstants);
  Writeitem(REG_TYPES, feTypes);
end;

end.