{(*}
(*------------------------------------------------------------------------------
 Delphi Code formatter source code 

The Original Code is SetIndent.pas, released April 2000.
The Initial Developer of the Original Code is Anthony Steele. 
Portions created by Anthony Steele are Copyright (C) 1999-2000 Anthony Steele.
All Rights Reserved. 
Contributor(s): Anthony Steele. 

The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"). you may not use this file except in compliance with the License.
You may obtain a copy of the License at http://www.mozilla.org/NPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied.
See the License for the specific language governing rights and limitations 
under the License.
------------------------------------------------------------------------------*)
{*)}

unit SetIndent;

interface

uses SetBase, TokenType;

type

  TSetIndent = class(TSetBase)
  private
    fiIndentSpaces: integer;

    fbIndentGlobals: boolean;
    fbIndentClasses: boolean;
    fbIndentProcedures: boolean;

  public
    constructor Create;

    procedure Read; override;
    procedure Write; override;

    property IndentSpaces: integer read fiIndentSpaces write fiIndentSpaces;

    property IndentGlobals: boolean read fbIndentGlobals write fbIndentGlobals;
    property IndentClasses: boolean read fbIndentClasses write fbIndentClasses;
    property IndentProcedures: boolean read fbIndentProcedures write fbIndentProcedures;

  end;

implementation

const
  REG_INDENTATION_SPACES = 'IndentationSpaces';

  REG_INDENT_GLOBALS    = 'IndentGlobals';
  REG_INDENT_CLASSES    = 'IndentClasses';
  REG_INDENT_PROCEDURES = 'IndentProcedures';


  { TSetIndent }

constructor TSetIndent.Create;
begin
  inherited;
  SetSection('Indent');
end;

procedure TSetIndent.Read;
begin
  fiIndentSpaces := ReadItem(REG_INDENTATION_SPACES, 2);

  fbIndentGlobals    := ReadItem(REG_INDENT_GLOBALS, True);
  fbIndentClasses    := ReadItem(REG_INDENT_CLASSES, True);
  fbIndentProcedures := ReadItem(REG_INDENT_PROCEDURES, True);
end;

procedure TSetIndent.Write;
begin
  WriteItem(REG_INDENTATION_SPACES, fiIndentSpaces);

  WriteItem(REG_INDENT_GLOBALS, fbIndentGlobals);
  WriteItem(REG_INDENT_CLASSES, fbIndentClasses);
  WriteItem(REG_INDENT_PROCEDURES, fbIndentProcedures);
end;

end.