{(*}
(*------------------------------------------------------------------------------
 Delphi Code formatter source code 

The Original Code is frExcludeFiles.pas, released April 2000.
The Initial Developer of the Original Code is Anthony Steele. 
Portions created by Anthony Steele are Copyright (C) 1999-2000 Anthony Steele.
All Rights Reserved. 
Contributor(s): Anthony Steele. 

The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"). you may not use this file except in compliance with the License.
You may obtain a copy of the License at http://www.mozilla.org/NPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied.
See the License for the specific language governing rights and limitations 
under the License.
------------------------------------------------------------------------------*)
{*)}

unit frExcludeFiles;

interface

uses
    { delphi }
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    { local }
  SettingsFrame, StdCtrls, MemoEx;

type
  TfExcludeFiles = class(TfrSettingsFrame)
    mFiles: TMemoEx;
    lblCaption: TLabel;
    procedure FrameResize(Sender: TObject);
  private
  public
    procedure Read; override;
    procedure Write; override;
    function Caption: string; override;

  end;

implementation

{$R *.DFM}

{ TfExcludeFiles }

procedure TfExcludeFiles.Read;
begin
  mFiles.Lines.Assign(Settings.FileSettings.Exclusions);
end;

procedure TfExcludeFiles.Write;
begin
  Settings.FileSettings.Exclusions.Assign(mFiles.Lines);
end;

procedure TfExcludeFiles.FrameResize(Sender: TObject);
const
  PAD = 4;
begin
  mFiles.Height := ClientHeight - (lblCaption.Top + lblCaption.Height + PAD);
end;

function TfExcludeFiles.Caption: string;
begin
  Result := 'Exclude files';
end;

end.