{(*}
(*------------------------------------------------------------------------------
 Delphi Code formatter source code 

The Original Code is IntList.pas, released April 2000.
The Initial Developer of the Original Code is Anthony Steele. 
Portions created by Anthony Steele are Copyright (C) 1999-2000 Anthony Steele.
All Rights Reserved. 
Contributor(s): Anthony Steele. 

The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"). you may not use this file except in compliance with the License.
You may obtain a copy of the License at http://www.mozilla.org/NPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied.
See the License for the specific language governing rights and limitations 
under the License.
------------------------------------------------------------------------------*)
{*)}

unit IntList;

{ AFS 2 April 2K
  A old concept, and a generic class
  implemented here because I needed it in the LineBreaker

  The internals are a hack, but so what?
  They are internal & could be replaced if need be by a more normal implementation

  anyway it works because a pointer = 4 bytes, an int = 4 bytes
  If this changes this will break
}


interface

uses Classes, SysUtils;

type

  TIntList = class
  private
    fcList: TList;

    function Get_Item(piIndex: integer): integer;
    procedure Set_Item(piIndex: integer; const Value: integer);

  protected

  public
    constructor Create;
    destructor Destroy; override;


    function Count: integer;

    function Add(piValue: integer): integer;
    procedure Clear;
    procedure ChangeValue(liIndex, liDelta: integer);

    function IndexOfMax: integer;

    property Items [piIndex: integer]: integer read Get_Item write Set_Item;
  end;

implementation

{ TIntList }

constructor TIntList.Create;
begin
  inherited;
  fcList := TList.Create;
end;

destructor TIntList.Destroy;
begin
  FreeAndNil(fcList);
  inherited;
end;

function TIntList.Add(piValue: integer): integer;
begin
  Result := fcList.Add(Pointer(piValue));
end;

procedure TIntList.Clear;
begin
  fcList.Clear;
end;

function TIntList.Count: integer;
begin
  Result := fcList.Count;
end;


function TIntList.Get_Item(piIndex: integer): integer;
begin
  Result := integer(fcList.Items[piIndex]);
end;

procedure TIntList.Set_Item(piIndex: integer; const Value: integer);
begin
  fcList.Items[piIndex] := Pointer(Value);
end;

procedure TIntList.ChangeValue(liIndex, liDelta: integer);
begin
  { can fall out of bounds, easiest to ignore it here }
  if (liIndex < 0) or (liIndex >= Count) then
    exit;

  Items[liIndex] := Items[liIndex] + liDelta;
end;

function TIntList.IndexOfMax: integer;
var
  liItem, liMax: integer;
  liLoop:        integer;
begin
  Result := -1;
  liMax  := Low(integer);

  for liLoop := 0 to Count - 1 do
  begin
    liItem := Items[liLoop];
    { the >= is a hack kinda but for the purposes of the linebreaker,
      in case of a tie, take the last item }

    if liItem >= liMax then
    begin
      liMax  := liItem;
      Result := liLoop;
    end;
  end;
end;

end.