unit fSingleSettings;

interface

uses
    { delphi }
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,
    { local } Settings, SettingsFrame;

type
  TfrmSingleSettings = class(TForm)
    bbOK: TBitBtn;
    bbCancel: TBitBtn;
    procedure bbCancelClick(Sender: TObject);
    procedure bbOKClick(Sender: TObject);
  private
    frSettings: TfrSettingsFrame;
    fcSettings: TSettings;
  public

    procedure Execute; overload;
    procedure Execute(frClass: TSettingsFrameClass); overload;

    property SettingsFrame: TfrSettingsFrame read frSettings write frSettings;

    property Settings: TSettings read fcSettings write fcSettings;
  end;


implementation

{$R *.DFM}

procedure TfrmSingleSettings.Execute(frClass: TSettingsFrameClass);
var
  lfr: TfrSettingsFrame;
begin
  lfr := frClass.Create(self);
  try
    SettingsFrame := lfr;
    Caption       := SettingsFrame.Caption;
    Execute;
  finally
    lfr.Free;
  end;
end;

procedure TfrmSingleSettings.Execute;
const
  LITTLE_PAD = 2;
  BIG_PAD    = 6;
var
  liMid: integer;
begin
  Assert(Settings <> nil);
  Assert(SettingsFrame <> nil);

  if SettingsFrame.Settings = nil then
    SettingsFrame.Settings := Settings;

  SettingsFrame.Read;

  SettingsFrame.Left := LITTLE_PAD;
  SettingsFrame.Top  := LITTLE_PAD;

  { reposition the buttons tops }
  bbOK.Top     := SettingsFrame.Top + SettingsFrame.Height + BIG_PAD;
  bbCancel.Top := bbOK.Top;

  { resize self to fit the frame }
  Width  := SettingsFrame.Width + (LITTLE_PAD * 2) + (Width - ClientWidth);
  Height := (Height - ClientHeight) + bbOK.Top + bbOK.Height + BIG_PAD;


  { center he buttons }
  liMid     := ClientWidth div 2;
  bbOK.Left := liMid - (bbOk.Width + BIG_PAD);
  bbCancel.Left := liMid + BIG_PAD;

  { showtime! }
  SettingsFrame.Parent  := self;
  SettingsFrame.Visible := True;
  ShowModal;
end;

{-------------------------------------------------------------------------------
  event handlers }

procedure TfrmSingleSettings.bbCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmSingleSettings.bbOKClick(Sender: TObject);
begin
  if SettingsFrame <> nil then
    SettingsFrame.Write;

  Close;
end;

end.