unit wdmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Wizards, Grids, Outline, DirOutln;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Bevel1: TBevel;
    Panel2: TPanel;
    Bevel2: TBevel;
    Wizard1: TWizard;
    BtnBack: TButton;
    BtnNext: TButton;
    ExitBtn: TButton;
    StaticTextHeader: TStaticText;
    StaticTextInfo: TStaticText;
    StaticText1: TStaticText;
    RadioGroup1: TRadioGroup;
    DirectoryOutline1: TDirectoryOutline;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    TextPageIndicator: TStaticText;
    StaticText4: TStaticText;
    CheckBox2: TCheckBox;
    procedure ExitBtnClick(Sender: TObject);
    procedure Wizard1ButtonFinishClick(Sender: TObject);
    procedure Wizard1EnteringPage(Sender: TObject; CurrentPage: Integer;
      Direction: TWizardDirection);
    procedure Wizard1ButtonNextClick(Sender: TObject; CurrentPage: Integer;
      var AllowMove: Boolean);
    procedure Wizard1PageChanged(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ExitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Wizard1ButtonFinishClick(Sender: TObject);
begin
  if MessageDlg('Close the wizard?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    Close;
end;

procedure TForm1.Wizard1EnteringPage(Sender: TObject; CurrentPage: Integer;
  Direction: TWizardDirection);
begin
  case CurrentPage of
    0: if Direction = wdBackward then
         ShowMessage('A-ha! Moving backwards!');
    1: if Direction = wdForward then
         Wizard1.NextEnabled := RadioGroup1.ItemIndex = 0;
  end;
end;

procedure TForm1.Wizard1ButtonNextClick(Sender: TObject;
  CurrentPage: Integer; var AllowMove: Boolean);
begin
  if CurrentPage = 3 then
    AllowMove := LowerCase(Trim(Edit1.Text)) = 'password';
end;

procedure TForm1.Wizard1PageChanged(Sender: TObject);
begin
  TextPageIndicator.Caption := 'Current page: ' + IntToStr(Wizard1.PageIndex);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  Wizard1.NextEnabled := RadioGroup1.ItemIndex = 0;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Wizard1.SetSkipPage(3, CheckBox1.Checked);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  Wizard1.HideButtons := CheckBox2.Checked;
end;

end.
