unit regBinaryData;

interface

uses
  DsgnIntf;

type
  TBinaryDataEditor = class (TComponentEditor)
  public
    function GetVerbCount : integer; override;
    function GetVerb (index : integer) : string; override;
    procedure ExecuteVerb (index : integer); override;
    procedure Edit; override;
  end;

procedure Register;

implementation

uses
  uBinaryData, Dialogs, classes, Forms, SysUtils;

{ TBinaryDataEditor }

function TBinaryDataEditor.GetVerbCount;
begin
  Result := 1;
end;

function TBinaryDataEditor.GetVerb;
begin
  Result := 'Load File...';
end;

procedure TBinaryDataEditor.ExecuteVerb;
begin
  Edit;
end;

procedure TBinaryDataEditor.Edit;
var
  OpenDialog : TOpenDialog;
  FileStream : TFileStream;
begin
  OpenDialog := TOpenDialog.Create (Application);
  try
    OpenDialog.Filter := '*.*';
    if OpenDialog.Execute
      then if FileExists (OpenDialog.Filename)
        then
        begin
          FileStream := TFileStream.Create (OpenDialog.Filename, fmOpenRead);
          try
            (Component as TBinaryData).Stream := FileStream;
            Designer.Modified;
          finally
            FileStream.Free;
          end;
        end;
  finally
    OpenDialog.Free;
  end;
end;

procedure Register;
begin
  RegisterComponents('Misc', [TBinaryData]);
  RegisterComponentEditor (TBinaryData, TBinaryDataEditor);
end;

end.
